{% from 'components/freigabestatus_badge.html.jinja' import freigabestatus_badge %}
{% from 'components/bob_badge.html.jinja' import bob_badge %}

{% macro _title(id, name, href) %}
  <span class="text-muted">{{ id }}</span>
  <a class="tree-title-link" href="{{ href }}">
    <p class="mb-0 fw-semibold">{{ name }}</p>
  </a>
{% endmacro %}

{% macro _header_badges(anzahl, parent_bezug, name) %}
  {% if anzahl %}
    <span class="badge badge-light">{{ anzahl }}</span>
  {% endif %}
  {% if parent_bezug %}
    <button
      class="bezug-toggle"
      aria-label="Rechtsgrundlagen {{ name }} anzeigen"
      data-bs-toggle="tooltip"
      data-bs-placement="right"
      data-bs-title="Rechtsgrundlagen"
    >
      <small class="d-flex align-items-center gap-1">
        §
        <i class="bi bi-chevron-down" aria-hidden="true"></i>
      </small>
    </button>
  {% endif %}
{% endmacro %}

{% macro _render_field(field, anzahl, parent_bezug, parent_id) %}
  <div class="tree-item">
    <div class="tree-header">
      <i class="bi bi-input-cursor-text"></i>
      <div class="tree-header-content">
        <div>
          {{ _title(field.fim_id, field.name, field.href) }}
          {{ _header_badges(anzahl, parent_bezug, field.name) }}
        </div>
        <div>
          {% if field.is_bob %}
            {{ bob_badge() }}
          {% endif %}
          {{ freigabestatus_badge(field.freigabe_status) }}
          <span class="text-muted">Version {{ field.fim_version }}</span>
        </div>
      </div>
    </div>

    {% if parent_bezug %}
      {{ _render_bezug_container(parent_bezug, parent_id, field.fim_id) }}
    {% endif %}
  </div>
{% endmacro %}

{% macro _render_group(group, anzahl, parent_bezug, parent_id) %}
  <div class="tree-item open" open>
    <div class="tree-header">
      <button
        class="tree-toggle"
        aria-label="Gruppe ein/ausklappen {{ group.name }}"
      >
        <i class="bi bi-tree-toggle" aria-hidden="true"></i>
      </button>
      <div class="tree-header-content">
        <div>
          {{ _title(group.fim_id, group.name, group.href) }}
          {{ _header_badges(anzahl, parent_bezug, group.name) }}
        </div>
        <div>
          {% if group.is_bob %}
            {{ bob_badge() }}
          {% endif %}
          {{ freigabestatus_badge(group.freigabe_status) }}
          <span class="text-muted">Version {{ group.fim_version }}</span>
        </div>
      </div>
    </div>

    {% if parent_bezug %}
      {{ _render_bezug_container(parent_bezug, parent_id, group.fim_id) }}
    {% endif %}
    {{ _render_child_container(group.fim_id, group.children) }}
  </div>
{% endmacro %}

{% macro _render_child_container(parent_id, children) %}
  <div class="tree-child-container">
    {% for child in children %}
      {% if child.element.child_type == "field" %}
        {{ _render_field(child.element, child.get_anzahl_label(), child.bezug, parent_id) }}
      {% else %}
        {{ _render_group(child.element, child.get_anzahl_label(), child.bezug, parent_id) }}
      {% endif %}
    {% endfor %}
  </div>
{% endmacro %}

{% macro _render_bezug_container(bezug, parent_id, child_id) %}
  <div class="bezug-container">
    <div class="bezug-header">
      <div>
        <span class="fw-semibold">{{ child_id }}</span> kommt vor in
        <span class="fw-semibold">{{ parent_id }}</span> auf Grundlage von:
      </div>
      <button type="button" class="btn-close" aria-label="Close"></button>
    </div>
    <ul>
      {% for item in bezug %}
        <li>{{ item }}</li>
      {% endfor %}
    </ul>
  </div>
{% endmacro %}

{% macro render_schema_tree(schema_tree) %}
  <div class="tree-item open">
    <div class="tree-header">
      <i class="bi bi-file-text"></i>
      <div class="tree-header-content">
        <div>{{ _title(schema_tree.fim_id, schema_tree.name, "#") }}</div>
        <div>
          {{ freigabestatus_badge(schema_tree.freigabe_status) }}
          <span class="text-muted">Version {{ schema_tree.fim_version }}</span>
        </div>
      </div>
    </div>
    {{ _render_child_container(schema_tree.fim_id, schema_tree.children) }}
  </div>
{% endmacro %}

{% macro render_group_tree(group_tree) %}
  {{ _render_group(group_tree, none, none) }}
{% endmacro %}
